package servlets;

import java.io.IOException;
import java.nio.file.Paths;
import java.util.HashSet;
import java.util.Set;

import javax.servlet.ServletException;
import javax.servlet.annotation.MultipartConfig;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.Part;

import datatypes.DtActividadDeportiva;
import datatypes.DtFecha;
import datatypes.DtProfesorExt;
import datatypes.TEstado;
import excepciones.ActividadDeportivaException;
import models.IActividadDeportivaController;
import models.LaFabricaWS;
import tools.Parametrizer;

@MultipartConfig
@WebServlet ("/alta_ad")
public class AltaAD extends HttpServlet {
	private static IActividadDeportivaController IADC;
	private static final long serialVersionUID = 1L;
    public AltaAD() {
        super();
        IADC = LaFabricaWS.getInstance().obtenerIActDeportivaController();
    }
    protected void processRequest(HttpServletRequest r,  HttpServletResponse response) throws ServletException,  IOException {
    	String ua=r.getHeader("User-Agent").toLowerCase();
    	if(ua.matches("(?i).*((android|bb\\d+|meego).+mobile|avantgo|bada\\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\\.(browser|link)|vodafone|wap|windows ce|xda|xiino).*")||ua.substring(0,4).matches("(?i)1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\\-(n|u)|c55\\/|capi|ccwa|cdm\\-|cell|chtm|cldc|cmd\\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\\-s|devi|dica|dmob|do(c|p)o|ds(12|\\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\\-|_)|g1 u|g560|gene|gf\\-5|g\\-mo|go(\\.w|od)|gr(ad|un)|haie|hcit|hd\\-(m|p|t)|hei\\-|hi(pt|ta)|hp( i|ip)|hs\\-c|ht(c(\\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\\-(20|go|ma)|i230|iac( |\\-|\\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\\/)|klon|kpt |kwc\\-|kyo(c|k)|le(no|xi)|lg( g|\\/(k|l|u)|50|54|\\-[a-w])|libw|lynx|m1\\-w|m3ga|m50\\/|ma(te|ui|xo)|mc(01|21|ca)|m\\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\\-2|po(ck|rt|se)|prox|psio|pt\\-g|qa\\-a|qc(07|12|21|32|60|\\-[2-7]|i\\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\\-|oo|p\\-)|sdk\\/|se(c(\\-|0|1)|47|mc|nd|ri)|sgh\\-|shar|sie(\\-|m)|sk\\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\\-|v\\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\\-|tdg\\-|tel(i|m)|tim\\-|t\\-mo|to(pl|sh)|ts(70|m\\-|m3|m5)|tx\\-9|up(\\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\\-|your|zeto|zte\\-")) {
    	  r.getRequestDispatcher("pages/404.jsp").forward(r,  response);
    	  return;
    	}
    	r.setCharacterEncoding("utf-8");
    	response.setCharacterEncoding("utf-8");
    	String ru = r.getParameter("miurl");
        DtProfesorExt p = (DtProfesorExt) r.getSession().getAttribute("loggedUser");
        Set<String> cats = new HashSet<>();
        if (rp(r, "catAD") != null)
	        for (String c: rp(r, "catAD").split("[, ]")) {
	        	cats.add(c);
	        }
        String filename=null;
        if (r.getPart("imgAD")!=null && r.getPart("imgAD").getSize()>0) {
        	Part filePart = r.getPart("imgAD");
    		String [] s = Paths.get(filePart.getSubmittedFileName()).getFileName().toString().split("[.]");
    		String ext = s[s.length-1];
    		filename=rp(r, "nombreAD")+"."+ext;
        }
    	int duracion = Integer.parseInt(rp(r, "durAD").trim());
    	float costo = Float.parseFloat(rp(r, "costoAD").trim());
        DtActividadDeportiva datosAD = new DtActividadDeportiva(rp(r, "nombreAD"), rp(r, "descAD"), duracion, costo, 
        		new DtFecha(), new HashSet<String>(), TEstado.ingresada, p.getNickname(), filename); //cat    
        try {
	        if (IADC.ingresarDatosActividadDep(p.getNombreInstitucion(),  datosAD)) {
	    		ru=Parametrizer.remParam(ru,  "e",  "4");
	    		ru=Parametrizer.addParam(ru,  "e",  "5");
	    		if (r.getPart("imgAD")!=null && r.getPart("imgAD").getSize()>0) {
		        	Part filePart = r.getPart("imgAD");
	        		String [] s = Paths.get(filePart.getSubmittedFileName()).getFileName().toString().split("[.]");
	        		String ext = s[s.length-1];
		        	r.setAttribute("type", "act");
		        	r.setAttribute("id", rp(r, "nombreAD")+"."+ext);
		        	r.setAttribute("attribute_asset_transfer", filePart);
		        	ContentHandler.postContent(r,response);
		        }
	    		clearctx(r);
	    		
			} else {
				ru=Parametrizer.remParam(ru,  "e",  "5");
				ru=Parametrizer.addParam(ru,  "e",  "4");
				savectx(r);
	        }
        }catch(ActividadDeportivaException e) {
        	System.out.println("INFO: "+e.getMessage());
        	ru=Parametrizer.remParam(ru,  "e",  "5");
        	ru=Parametrizer.addParam(ru,  "e",  "4");
        	savectx(r);
        }catch(Exception e) {
		   e.printStackTrace();
		   ru=Parametrizer.remParam(ru,  "e",  "5");
		   ru=Parametrizer.addParam(ru,  "e",  "4");
		   savectx(r);
	   }
       response.sendRedirect(ru);
    }
	protected void doPost(HttpServletRequest request,  HttpServletResponse response) throws ServletException,  IOException {
        processRequest(request,  response);
	}
	
	private String rp(HttpServletRequest request, String param) {
		return request.getParameter(param);
	}
	private void savectx(HttpServletRequest r) {
		r.getSession().setAttribute("ctxnombreAD",rp(r,"nombreAD"));
		r.getSession().setAttribute("ctxdescAD",rp(r,"descAD"));
		r.getSession().setAttribute("ctxdurAD",rp(r,"durAD"));
		r.getSession().setAttribute("ctxcostoAD",rp(r,"costoAD"));
	}
	private void clearctx(HttpServletRequest r) {
		r.getSession().setAttribute("ctxnombreAD",null);
		r.getSession().setAttribute("ctxdescAD",null);
		r.getSession().setAttribute("ctxdurAD",null);
		r.getSession().setAttribute("ctxcostoAD",null);
	}
}